// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once

#include <memory>
#include "ISCW_UObject.h"

using std::shared_ptr;

namespace Sourcify
{	
	class ISCW_FEdGraphTerminalType
	{
	public:
		virtual ~ISCW_FEdGraphTerminalType() = default;

		virtual bool ISCW_Equals(shared_ptr<const ISCW_FEdGraphTerminalType> Other) const = 0;

		virtual ISCW_UObjectPtr GetTerminalSubCategoryObject() const = 0;
		virtual void SetTerminalSubCategoryObject(ISCW_UObjectPtr InObjectPtr) const = 0;

		virtual shared_ptr<ISCW_FEdGraphTerminalType> ToFEdGraphTerminalTypePtr() = 0;
		virtual shared_ptr<const ISCW_FEdGraphTerminalType> ToFEdGraphTerminalTypePtr() const = 0;
	};

	using ISCW_FEdGraphTerminalTypeConstPtr = shared_ptr<const ISCW_FEdGraphTerminalType>;
	using ISCW_FEdGraphTerminalTypePtr = shared_ptr<ISCW_FEdGraphTerminalType>;
} // namespace Sourcify